<?php
namespace Teknisa\EST\Modules\Relatorios\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DataSource\FilterCriteria;

class Est33401RequisicaoDeEstoque {
    protected $reportService;
    protected $dataSourceManager;
    protected $nrorg;

    public function __construct(ReportService $reportService, $dataSourceManager, $environment) {
        $this->reportService       = $reportService;
        $this->dataSourceManager   = $dataSourceManager;
        $this->nrorg = $environment->getNrorgTrab();
        
    }

    public function generateReport(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        
        $reportName = $row['NMRELATORIO'];
        
        $parametersRow = array();
        
        $parametersRow['P_NRORG'] = $this->nrorg;
        $parametersRow['P_CDFILIAL'] = $row['CDFILIAL'];
        if ($row['CDALMOXDEST']!== ''){
            $parametersRow['P_ALMOXARIFE'] = $row['CDALMOXDEST'];
            $parametersRow['P_TALMOXARIFE'] = $row['CDALMOXDEST'];
        }else{
            $parametersRow['P_ALMOXARIFE'] = 'T';
            $parametersRow['P_TALMOXARIFE'] = 'T';
        }
        if ($row['CDLOCALDEST']!== ''){
            $parametersRow['P_LOCALIZA'] = $row['CDLOCALDEST'];
            $parametersRow['P_TLOCALIZA'] = $row['CDLOCALDEST'];
        }else{
            $parametersRow['P_LOCALIZA'] = 'T';
            $parametersRow['P_TLOCALIZA'] = 'T';
        }
        if ($row['CDALMOXORIG']!== ''){
            $parametersRow['P_ALMOXORI'] = $row['CDALMOXORIG'];
            $parametersRow['P_TALMOXORI'] = $row['CDALMOXORIG'];
        }else{
            $parametersRow['P_ALMOXORI'] = 'T';
            $parametersRow['P_TALMOXORI'] = 'T';
        }
        if ($row['CDLOCALORIG']!== ''){
            $parametersRow['P_LOCALIZAORI'] = $row['CDLOCALORIG'];
            $parametersRow['P_TLOCALIZAORI'] = $row['CDLOCALORIG'];
        }else{
            $parametersRow['P_LOCALIZAORI'] = 'T';
            $parametersRow['P_TLOCALIZAORI'] = 'T';
        }
        $parametersRow['P_NRREQUESTO'] = 'T';
        $parametersRow['P_TNRREQUESTO'] = 'T';
        $parametersRow['P_DATAINI'] = $row['DTREQUESTO']['start'];
        $parametersRow['P_DATAFIN'] = $row['DTREQUESTO']['end'];
        $parametersRow['__format'] = $row["__FORMAT"];
        
        $birtURL = $this->reportService->createRemoteReport('BIRT', $reportName, $parametersRow);
        $birtLink = $this->reportService->createRemoteReport('BIRT', $reportName, $parametersRow, true);
        
        $response->addMessage(new DTO\Response\Message($birtLink)); 
        $response->addMessage(new DTO\Response\Message($birtURL));
    }   

}