package com.javaseleniumtemplate.tests.naocontrolaalmoxarifado;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.dbsteps.DBSteps;

import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.MainFlows;

import com.javaseleniumtemplate.flows.naocontrolaalmoxarifado.AjusteInventarioNaoControlaAlmoxarifadoFlows;
import com.javaseleniumtemplate.pages.MainPage;
import com.javaseleniumtemplate.pages.naocontrolaalmoxarifado.AjusteInventarioNaoControlaAlmoxarifadoPage;
import org.testng.Assert;
import org.testng.annotations.Ignore;
import org.testng.annotations.Test;

public class AjusteDeInventarioNaoControlaAlmoxarifadoTests extends TestBase {
    MainPage mainPage;
    LoginFlows loginFlows;
    MainFlows mainFlows;
    AjusteInventarioNaoControlaAlmoxarifadoFlows ajusteInventarioNaoControlaAlmoxarifadoFlows;
    AjusteInventarioNaoControlaAlmoxarifadoPage ajusteInventarioNaoControlaAlmoxarifadoPage;


    @Test(description = "Est-04")
    @Ignore
    public void EfetuarAjusteInventario() {

        //Objects instances
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        ajusteInventarioNaoControlaAlmoxarifadoFlows = new AjusteInventarioNaoControlaAlmoxarifadoFlows();
        ajusteInventarioNaoControlaAlmoxarifadoPage = new AjusteInventarioNaoControlaAlmoxarifadoPage();


        //ParameteresLançamento:
        String quantidade = "5";
        String cmpDesc = "Teste Automatizado";
        String descProduto = "Hela Poultry Broth Paste Clear KG";
        String descAlmoxarifado = "HELA MATRIZ";
        String descLote = "00231100";
        String descUnidade = "HELA INGREDIENTES BRASIL";
        String descOperador = "Deivison";
        String valorEstoqueEsperado = "5";
        String valorUnitarioLancado = "0";


        //Rotinas:
        loginFlows.efetuarLogin();
        mainFlows.AcessandoTrocaUnidadeNaoControlaAlmoxarifado();
        mainFlows.AcessandoAjusteInventario();
       ajusteInventarioNaoControlaAlmoxarifadoFlows.aplicarFiltro(descUnidade, descOperador);
        ajusteInventarioNaoControlaAlmoxarifadoFlows.adicionarAjusteIventario(quantidade, cmpDesc, descProduto, descAlmoxarifado, descLote);

        //Banco

        String numeroLancamento = ajusteInventarioNaoControlaAlmoxarifadoPage.retornaNumeroLacamento();
        Assert.assertTrue(DBSteps.retornaQuatidadeEstoque(numeroLancamento).contains(valorEstoqueEsperado));
        String valorLancamentoTotalEstoque = ajusteInventarioNaoControlaAlmoxarifadoPage.retornaNumeroLacamento();
        //Assert.assertTrue(DBSteps.retornaValorTotalQuantidadeEstoque(valorLancamentoTotalEstoque).contains(valorTotalEstoqueEsperado));
        Assert.assertEquals(numeroLancamento, valorLancamentoTotalEstoque, "comparação entre o valor lançado e o valor que tem em estoque");
        Assert.assertTrue(DBSteps.retornaValorUnitarioLancadoEstoque(numeroLancamento).contains(valorUnitarioLancado));//verifica o valor lançado no banco do valor unitario


    }

   @Test(description = "Est-05")
   @Ignore
    public void EditarAjusteInventario() {

        //Objects instances
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        ajusteInventarioNaoControlaAlmoxarifadoFlows = new AjusteInventarioNaoControlaAlmoxarifadoFlows();
        ajusteInventarioNaoControlaAlmoxarifadoPage = new AjusteInventarioNaoControlaAlmoxarifadoPage();


        //ParameteresLançamento:

        String descAlmoxarifado = "HELA MATRIZ";
        String descUnidade = "HELA INGREDIENTES BRASIL";
        String descOperador = "Deivison";
        //Parameteres_Editar
        String quantidade2 = "2";
        String cmpDesc2 = "Deletar";
        String descProduto2 = "Ochsenbuillon Paste (Hela 7565810050001)";
        String descLote2 = "20013001";


        loginFlows.efetuarLogin();
        mainFlows.AcessandoTrocaUnidadeNaoControlaAlmoxarifado();
        mainFlows.AcessandoAjusteInventario();
        ajusteInventarioNaoControlaAlmoxarifadoFlows.aplicarFiltro(descUnidade, descOperador);
        ajusteInventarioNaoControlaAlmoxarifadoFlows.editarAjusteIventario(cmpDesc2, quantidade2, descProduto2, descAlmoxarifado, descLote2);
    }

    @Test(description = "Est-06")
    @Ignore
    public void ExcluirAjusteInventario() {

        //Objects instances
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        ajusteInventarioNaoControlaAlmoxarifadoFlows = new AjusteInventarioNaoControlaAlmoxarifadoFlows();
        ajusteInventarioNaoControlaAlmoxarifadoPage = new AjusteInventarioNaoControlaAlmoxarifadoPage();


        //ParameteresLançamento:

        String descUnidade = "HELA INGREDIENTES BRASIL";
        String descOperador = "Deivison";


        //Rotinas:
        loginFlows.efetuarLogin();
        mainFlows.AcessandoAjusteInventario();
        ajusteInventarioNaoControlaAlmoxarifadoFlows.aplicarFiltro(descUnidade, descOperador);
        ajusteInventarioNaoControlaAlmoxarifadoFlows.excluirAjusteIventario();
    }

    @Test(description = "Est-07")
    @Ignore
    public void importarAjusteInventario() {

        //Objects instances
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        ajusteInventarioNaoControlaAlmoxarifadoFlows = new AjusteInventarioNaoControlaAlmoxarifadoFlows();
        ajusteInventarioNaoControlaAlmoxarifadoPage = new AjusteInventarioNaoControlaAlmoxarifadoPage();

        //Parameteres

        String descUnidade = "HELA INGREDIENTES BRASIL";
        String descOperador = "Deivison"; //  Constuido o caminho para ser usado somente com esse nome.

        loginFlows.efetuarLogin();
        mainFlows.AcessandoAjusteInventario();
        ajusteInventarioNaoControlaAlmoxarifadoFlows.aplicarFiltro(descUnidade, descOperador);
        ajusteInventarioNaoControlaAlmoxarifadoFlows.importarAjusteInventario();

    }


}



